<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="xml" indent="yes" version="1.0"	omit-xml-declaration="yes" />

	<xsl:template match="@*">
		<xsl:attribute name="{name()}"><xsl:value-of select="." /></xsl:attribute>
	</xsl:template>

	<xsl:template match="*">
		<xsl:choose>
			<xsl:when test="name()='parameterList'">
				<xsl:element name="{name()}">
					<xsl:apply-templates select="@*" />
					<xsl:apply-templates select="*" />
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="{concat(attribute::name, '__', position(), '__', ../attribute::name)}">
					<xsl:apply-templates select="@*" />
					<xsl:attribute name="pcmltype"><xsl:value-of select="name()" /></xsl:attribute>
					<xsl:choose>
						<xsl:when test="count(child::*)=0">
							<xsl:attribute name="value"><xsl:value-of select="text()" /></xsl:attribute>
						</xsl:when>
					</xsl:choose>
					<xsl:apply-templates select="*" />
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="pcml">
		<xsl:element name="{name()}">
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates select="*" />
		</xsl:element>
	</xsl:template>
</xsl:stylesheet>
