<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
	<xsl:output method="xml" indent="yes" version="1.0" />

	<xsl:template match="@*">
		<xsl:element name="xsd:attribute">
			<xsl:attribute name="name"><xsl:value-of select="name()" /></xsl:attribute>
			<xsl:attribute name="type">xsd:string</xsl:attribute>
			<xsl:attribute name="default"><xsl:value-of select="." /></xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template match="*" mode="e">
		<xsl:element name="xsd:element">
			<xsl:attribute name="name"><xsl:value-of select="concat(attribute::name, '__', position(), '__', ../attribute::name)" /></xsl:attribute>
			<xsd:complexType>
				<xsl:element name="xsd:attribute">
					<xsl:attribute name="name">pcmltype</xsl:attribute>
					<xsl:attribute name="type">xsd:string</xsl:attribute>
					<xsl:attribute name="default"><xsl:value-of select="name()" /></xsl:attribute>
				</xsl:element>
				
				<xsl:apply-templates select="@*" />
				
				<xsl:element name="xsd:attribute">
					<xsl:attribute name="name">value</xsl:attribute>
					<xsl:attribute name="type">xsd:string</xsl:attribute>
					<xsl:attribute name="default"><xsl:value-of select="." /></xsl:attribute>
				</xsl:element>
			</xsd:complexType>
		</xsl:element>
	</xsl:template>

	<xsl:template match="*" mode="d">
		<xsl:element name="xsd:element">
				<xsl:attribute name="ref"><xsl:value-of select="concat(attribute::name, '__', position(), '__', ../attribute::name)" /></xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template match="*" mode="c">
		<xsl:choose>
			<xsl:when test="name()='struct'">
		<xsl:element name="xsd:element">
			<xsl:attribute name="name"><xsl:value-of select="concat(attribute::name, '__', position(), '__', ../attribute::name)" /></xsl:attribute>
			<xsd:complexType>
				<xsd:sequence>
					<xsl:apply-templates select="*" mode="d" />
				</xsd:sequence>
				<xsl:apply-templates select="@*" />
				<xsl:element name="xsd:attribute">
					<xsl:attribute name="name">pcmltype</xsl:attribute>
					<xsl:attribute name="type">xsd:string</xsl:attribute>
					<xsl:attribute name="default"><xsl:value-of select="name()" /></xsl:attribute>
				</xsl:element>
			</xsd:complexType>
		</xsl:element>
		<xsl:apply-templates select="*" mode="e" /></xsl:when></xsl:choose>
	</xsl:template>

	<xsl:template match="*" mode="b">
		<xsl:choose>
			<xsl:when test="name()='program'">
				<xsl:element name="xsd:element">
					<xsl:attribute name="name"><xsl:value-of select="concat(attribute::name, '__', position(), '__', ../attribute::name)" /></xsl:attribute>
					<xsd:complexType>
						<xsd:sequence>
							<xsl:apply-templates select="*" mode="e" />
						</xsd:sequence>
						<xsl:element name="xsd:attribute">
							<xsl:attribute name="name">pcmltype</xsl:attribute>
							<xsl:attribute name="type">xsd:string</xsl:attribute>
							<xsl:attribute name="default"><xsl:value-of select="name()" /></xsl:attribute>
						</xsl:element>
						<xsl:apply-templates select="@*" />
					</xsd:complexType>
				</xsl:element>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*" mode="a">
		<xsd:element ref="{concat(attribute::name, '__', position(), '__', ../attribute::name)}">
			<xsl:attribute name="minOccurs">0</xsl:attribute>
		</xsd:element>
	</xsl:template>

	<xsl:template match="pcml">
		<xsd:schema>
			<!--base complex element-->
			<xsd:element name="xsd:element">
				<xsl:attribute name="name">pcml</xsl:attribute>
				<xsd:complexType>
					<xsd:sequence>
						<xsl:apply-templates select="*" mode="a" />
					</xsd:sequence>
					<xsd:attribute name="version" type="xsd:string" default="4.0" />
				</xsd:complexType>
			</xsd:element>
			<!--Struct complex element-->
			<xsl:apply-templates select="*" mode="c" />

			<xsl:apply-templates select="*" mode="b" />
		</xsd:schema>
	</xsl:template>
</xsl:stylesheet>